#include "global.h"

#define Write8(addr, data) *(volatile unsigned char*)(addr) = data
#define Write16(addr, data) *(volatile unsigned short*)(addr) = data
#define Write32(addr, data) *(volatile unsigned int*)(addr) = data
#define Read8(addr) *(volatile unsigned char*)(addr)
#define Read16(addr) *(volatile unsigned short*)(addr)
#define Read32(addr) *(volatile unsigned int*)(addr)

unsigned int PointerOffset;
unsigned int EncDataLength;
unsigned int ByteJump;
unsigned int DexOffset;

int RandMinMax(int low, int high)
{
	return low + (rand() % (high - low + 1));
}

bool isObtained(int value)
{
	if ((DexOffset >= 0x08000000) && (DexOffset < 0x08DF0000))
	{
		unsigned int ObtainedOffset = Read32(DexOffset);
		if ((ObtainedOffset >= 0x08000000) && (ObtainedOffset < 0x08DF0000))
		{
			//check if all obtained
			int i;
			for (i = 0; i < 721; i++)
			{
				if ((Read8(ObtainedOffset + 0x0C + (i / 8)) & (1 << (i % 8))) == 0)
				{
					break;
				}

				if (i == 720)
				{
					return false;
				}
			}

			//check if value is set
			if ((Read8(ObtainedOffset + 0x0C + ((value - 1) / 8)) & (1 << ((value - 1) % 8))) != 0)
			{
				return true;
			}
		}
	}
	return false;
}

int GetRandomPokemon()
{
	int result;

	do
	{
		result = RandMinMax(1, 721);
	}
	while (isObtained(result));

	switch (result)
	{
		//XY Forms
		case 421://Cherrim
		case 422://Shellos
		case 423://Gastrodon
		case 487://Giratina
		case 492://Shaymin
		case 550://Basculin
		case 555://Darmanitan
		case 641://Tornadus
		case 642://Thundurus
		case 645://Landoorus
		case 647://Keldeo
		case 648://Meloetta
		case 681://Aegislash
		case 716://Xerneas
		{
			result += (0x800 * RandMinMax(0, 1));
		}
		break;

		case 412://Burmy
		case 413://Wormadam
		case 646://Kyurem
		{
			result += (0x800 * RandMinMax(0, 2));
		}
		break;

		case 351://Castform
		case 386://Deoxys
		case 585://Deerling
		case 586://Sawsbuck
		case 710://Pumpkaboo
		case 711://Gourgeis
		{
			result += (0x800 * RandMinMax(0, 3));
		}
		break;

		case 649://Genesect
		case 669://Flabb 
		case 671://Florges
		{
			result += (0x800 * RandMinMax(0, 4));
		}
		break;

		case 479://Rotom
		case 670://Floette
		{
			result += (0x800 * RandMinMax(0, 5));
		}
		break;

		case 676://Furfrou
		{
			result += (0x800 * RandMinMax(0, 9));
		}
		break;

		case 493://Arceus
		{
			result += (0x800 * RandMinMax(0, 17));
		}
		break;

		case 666://Vivillon
		{
			result += (0x800 * RandMinMax(0, 19));
		}
		break;

		case 201://Unown
		{
			result += (0x800 * RandMinMax(0, 27));
		}
		break;

		//ORAS Forms
		case 26://Pikachu
		{
			if (PointerOffset == 0x08D06468)
			{
				result += (0x800 * RandMinMax(0, 6));
			}
		}
		break;

		case 720://Hoopa
		{
			if (PointerOffset == 0x08D06468)
			{
				result += (0x800 * RandMinMax(0, 1));
			}
		}
		break;

		//XY Megas 1
		case 3://Venusaur
		case 9://Blastoise
		case 65://Alakazam
		case 94://Gengar
		case 115://Kangaskhan
		case 127://Pinsir
		case 130://Gyarados
		case 142://Aerodactyl
		case 181://Ampharos
		case 208://Steelix
		case 212://Scizor
		case 214://Heracross
		case 229://Houndoom
		case 248://Tyranitar
		case 257://Blazikin
		case 282://Gardevoir
		case 303://Mawile
		case 306://Aggron
		case 308://Medicham
		case 310://Manectric
		case 354://Banette
		case 359://Absol
		case 380://Latias
		case 381://Latios
		case 445://Garchomp
		case 448://Lucario
		case 460://Abomasnow
		{
			result += (0x800 * RandMinMax(0, 1));
		}
		break;

		//XY Megas 2
		case 6://Charizard
		case 150://Mewtwo
		{
			result += (0x800 * RandMinMax(0, 2));
		}
		break;

		//ORAS Megas 1
		case 15://Beedrill
		case 18://Pidgeot
		case 80://Slowbro
		case 254://Sceptile
		case 260://Swampert
		case 302://Sableye
		case 319://Sharpedo
		case 323://Camerupt
		case 334://Altaria
		case 362://Glalie
		case 373://Salamence
		case 376://Metagross
		case 382://Kyogre
		case 383://Groudon
		case 384://Rayquaza
		case 428://Lopunny
		case 475://Gallade
		case 531://Audino
		case 719://Diancie
		{
			if (PointerOffset == 0x08D06468)
			{
				result += (0x800 * RandMinMax(0, 1));
			}
		}
		break;
	}
	return result;
}

void Randomize()
{
	unsigned int ZOOffset = Read32(PointerOffset);

	//Check for valid pointer
	if ((ZOOffset >= 0x08000000) && (ZOOffset < 0x08DF0000))
	{
		//Check if ZO File contains encounter data
		if (Read32(ZOOffset + 0x10) != Read32(ZOOffset + 0x14))
		{
			unsigned int EncOffset = ZOOffset + Read32(ZOOffset + 0x10) + ByteJump;

			int i;
			for (i = 0; i < EncDataLength; i += 4)
			{
				if (Read8(EncOffset + i + 2) != 0x01)
				{
					int Pokemon = GetRandomPokemon();
					Write16(EncOffset + i, Pokemon);
				}
			}

			//Update DexNav
			/*int j;
			for (i = 0; i < 96; i++)
			{
				for (j = 0; j < 0xF4; j += 4)
				{
					Write32(0x16B3E7B6 + (0x104 * i) + j, Read32(EncOffset + j));
				}
			}*/
		}
	}
}

void gamePluginEntry()
{
	//wait for the game to start up (5 seconds)
	svc_sleepThread(5000000000);
	
	srand(svc_getSystemTick());

	switch (Read32(0x0700010C))
	{
		//XY
		case 0x00055D00:
		case 0x00055E00:
		{
			PointerOffset = 0x08CEC564;
			EncDataLength = 0x178;
			ByteJump = 0x10;
			DexOffset = 0x08CC8D4C;
		}
		break;

		//ORAS
		case 0x0011C400:
		case 0x0011C500:
		{
			PointerOffset = 0x08D06468;
			EncDataLength = 0xF4;
			ByteJump = 0x0E;
			DexOffset = 0x08CE0CB8;
		}
		break;

		//Unknown Game
		default:
		{
			PointerOffset = 0x00;
			EncDataLength = 0x00;
			ByteJump = 0x00;
			DexOffset = 0x00;
		}
		break;
	}

	while (true)
	{
		if (PointerOffset != 0x00)
		{
			Randomize();
		}
		svc_sleepThread(1000000000);
	}
}